﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private manager As BleManager2
	Private rp As RuntimePermissions
	
	'''Device Found Id=[FF:FF:C0:20:9A:E5] Name=[iTAG            ], RSSI=-58
	Dim BLEId As String = "FF:FF:C0:20:9A:E5"
	
	'''Device Found Id=[F8:B4:86:32:9D:0A] Name=[34506               ], RSSI=-71
	Dim BLEId As String = "F8:B4:86:32:9D:0A"
	
	Dim BLEId as string = "CC:50:E3:99:B9:AA"    'Marco's SCP32
	
	Dim StartConnectTime As Long
	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
		
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub DoInitialize
	
	Log("DoInitialize")
	manager.Initialize("manager")
	
	Sleep(100)
	
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		Log("Good to go")
	End If
	
End Sub

Sub DoScan
	
	Log("DoScan")
	manager.Scan(Null)

End Sub

Sub DoScan2False
	
	Log("DoScan2False")
	manager.Scan2(Null, False)

End Sub

Sub DoScan2True
	
	Log("DoScan2True")
	manager.Scan2(Null, True)

End Sub

Sub DoStopScan

    Log("DoStopScan")
    manager.StopScan
		
End Sub

Sub DoConnect
	
	Log("DoConnect " & BLEId)
	manager.Connect(BLEId)
	
	StartConnectTime = DateTime.now
	
End Sub

Sub DoConnect2False
	
	Log("DoConnect2False " & BLEId)
	manager.Connect2(BLEId, False)
	
	StartConnectTime = DateTime.Now
	
End Sub

Sub DoConnect2True
	
	Log("DoConnect2True " & BLEId)
	manager.Connect2(BLEId, True)
	
	StartConnectTime = DateTime.Now
	
End Sub

Sub DoDisconnect
	
	Log("DoDisconnect")
	manager.Disconnect
	
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Log("Device Found Id=[" & Id & "] Name=[" & Name & "], RSSI=" & RSSI)
	
End Sub


Sub Manager_Connected(Services As List)
	
	Log("Manager_Connected")
	Log("connection time = " & NumberFormat2((DateTime.Now - StartConnectTime) / 1000, 1, 3, 3, False) & " s")
	
	For Each S As String In Services
		Log("  [" & S & "]")
	Next
	
End Sub

Sub Manager_DataAvailable(ServiceID As String, Characteristics As Map)
	
	Log("Manager_DataAvailable")
	
	For Each S As String In Characteristics.Keys
		Log("  [" & S & "]")
	Next

End Sub